
#include <vector>
#include <omnetpp.h>
#include "IPvXAddress.h"

// Statistics Vector
class StatEntry : public cPolymorphic {
	public:
		IPvXAddress deviceIP;
		int connId;
		int numSessions;
		int numMsgs;
		long bytesRcvd;
		simtime_t lastTime;
		simtime_t totalTime;
		simtime_t aveTime;
		simtime_t maxTime;

	private:
		// Copying not supported
		StatEntry(const StatEntry& obj);
		StatEntry& operator=(const StatEntry& obj);

	public:
		StatEntry();
		virtual ~StatEntry() {}
		virtual std::string info() const;
		virtual std::string detailedInfo() const;
};

//==============================================================

// TCP Application
class TCPServerStatApp : public cSimpleModule {
	protected:
		long bytesRcvd;
		int packetsRcvd;
		typedef std::vector<StatEntry *> StatVector;
		StatVector stats;

	protected:
		virtual void initialize();
		virtual void handleMessage(cMessage *msg);
		virtual void socketDataArrived(int connId, cMessage *msg);
		virtual void socketEstablished(int connId, IPvXAddress ip);
		virtual void socketPeerClosed(cMessage *msg);
		virtual void updateStats(StatEntry *se, cMessage *msg);
		virtual void updateTag();
		virtual void finish();
};
